/*****************************************
*
*	(c) 2016/2017 Dyrk.org
*	  dave-hill@dyrk.org
*		  BuildHTML		
*
*****************************************/


/*
 * 
 *	Start All Scripts
 *
 *
 */
var prompt2 = window.prompt;
test = localStorage.getItem('page');
var pages = (test)?test.split(';'):[];
console.log(pages);

var main = function(){
	ToolBoxEditor();
	BuildHTML();
	LoginButton();
}

window.addEventListener('load', main);


/*
 *
 *
 *	Convert Text to HTML
 *
 *
 */
var BuildHTML = function(){
  	var html = document.getElementById('main');
        var x = html.innerHTML;
        var replace={
                '\{\{(.*?)\}\}'         : "<img src='{data}' />",
                '#(.{0,1000})#'         : "<h1 style='color:red'>{data}</h1>",
                '--(.{0,1000})--' : "<b>{data}</b>",
                '\\+\\+(.{0,1000})\\+\\+'   : "<i>{data}</i>",
                '\\*(.*?)$'             : "<li>{data}</li>",
                '^(.*?)\:$'             : "<div style='text-decoration:underline;'>{data} :</div>",
                '\{(.*?)\}'             : "<a target=BLANK href='{data}'>link</a>"
        };
        while (x.indexOf(" ") != -1)  x = x.replace(" ","&nbsp;");
        for (var i in replace) while ((matchs = RegExp(i,"gm").exec(x)))
                x = x.replace( matchs[0], replace[i].replace('{data}', matchs[1]));
        while (x.indexOf("\n") != -1)  x = x.replace("\n","<br />");
        html.innerHTML = x;
};

/*
 * 	Display Login Form
 * 
 */
var LoginButton = function(){
	if (document.getElementById('loginButton')){
		document.getElementById('loginButton').addEventListener('mouseover', function(e){
			document.getElementById('login').style.display='block';
		});
	}
};

/*
 *
 *
 *	Detect cursor on textarea
 *
 *
 *
 */

var LastPosition=0;
var getCaretCharacterOffsetWithin = function(ctrl) {
       var CaretPos = 0;   // IE Support
      if (document.selection) {
		ctrl.focus ();
		var Sel = document.selection.createRange ();
		Sel.moveStart ('character', -ctrl.value.length);
		CaretPos = Sel.text.length;
	}
     else if (ctrl.selectionStart || ctrl.selectionStart == '0')
	 CaretPos = ctrl.selectionStart;
     return (CaretPos);
};



/*
 *
 *	Assoc function with Button on Editor
 *
 *
 */

var ToolBoxEditor = function(){
	var id ='html';
	if ( document.getElementById(id))
		document.getElementById(id).addEventListener('click', function(e){
		LastPosition = getCaretCharacterOffsetWithin(e.target);
		console.log(LastPosition);
	});
	id='ButTitle';
	if (document.getElementById(id))
		document.getElementById(id).addEventListener('click', function(){
		field  = prompt2('Title         !');
		var build = ' # '+field+' # ';
		var ntxt = document.getElementById('html').value;
		document.getElementById('html').value = ntxt.substr(0,LastPosition)+build+ntxt.substr(LastPosition, LastPosition.length);
	});
	 id='ButLink';
        if (document.getElementById(id))
                document.getElementById(id).addEventListener('click', function(){
                field  = prompt2('Url         !');
                var build = ' {'+field+'} ';
                var ntxt = document.getElementById('html').value;
                document.getElementById('html').value = ntxt.substr(0,LastPosition)+build+ntxt.substr(LastPosition, LastPosition.length);
        });

	 id='ButBold';
        if (document.getElementById(id))
                document.getElementById(id).addEventListener('click', function(){
                field  = prompt2('Text         !');
                var build = '--'+field+'--';
                var ntxt = document.getElementById('html').value;
                document.getElementById('html').value = ntxt.substr(0,LastPosition)+build+ntxt.substr(LastPosition, LastPosition.length);
        });
	 id='ButItalic';
        if (document.getElementById(id))
                document.getElementById(id).addEventListener('click', function(){
                field  = prompt2('Text         !');
                var build = '++'+field+'++';
                var ntxt = document.getElementById('html').value;
                document.getElementById('html').value = ntxt.substr(0,LastPosition)+build+ntxt.substr(LastPosition, LastPosition.length);
        });
	id='UpPic';
        if (document.getElementById(id))
                document.getElementById(id).addEventListener('change', readPicture);

	// Record ID page on local computer
	id="submit_html";
	if (document.getElementById(id))
                document.getElementById(id).addEventListener('click', function(){
			var id="",url=document.location+" ";
			if ((id = /id=([0-9]{0,100})/.exec(url))){
				if (! inArray(pages, id[1])) 
					pages.push(id[1]);
				localStorage.setItem('page',pages.join(';'));
				alert("Recorded as "+id[1]);
				document.getElementById('editor').submit();
			}  
		});

	// Fill the select page form
	id="select_edit_page";
	if (document.getElementById(id)){
		for (var i in pages){
			var op = document.createElement('option');
			op.value = op.innerHTML = pages[i];
			document.getElementById(id).appendChild(op);
		}
		
		document.getElementById(id).addEventListener('change', function(e){ document.location="index.php?id="+e.target.value; });
	}

}



/*
 * 
 *	Annex : Check if value is in array
 *
 */

var inArray = function(arr,val){
	for (var i in arr){
		if (arr[i] === val) 
			return true;
	}
	return false;
}

/*
 *
 *
 *	Read File picture
 *
 */



var readPicture = function(evt) {
    var f = evt.target.files[0]; 
    if (f) {
      var r = new FileReader();
      r.onload = function(e) { 
	    var contents = e.target.result; 
	    var build    = '{{'+contents+'}}'            
            var ntxt     = document.getElementById('html').value;
            document.getElementById('html').value = ntxt.substr(0,LastPosition)+build+ntxt.substr(LastPosition, LastPosition.length);		
      }
      r.readAsDataURL(f);
    } else { 
      alert("Failed to load file");
    }
  }




